From 2dbd64dcb55a88b925ba26fe7c6d48c9a714c02d Mon Sep 17 00:00:00 2001
From: Masahiko Sawada <sawada.mshk@gmail.com>
Date: Wed, 15 Jul 2026 23:43:53 +0000
Subject: [PATCH v20 2/2] Support parallel heap vacuum for collecting dead
 items

Extend vacuum to scan the heap, pruning and freezing tuples and
collecting dead item TIDs, using parallel workers. This adds to the
existing parallel index vacuuming, so scanning the heap, vacuuming
indexes, and cleaning up indexes can all run in parallel.

The leader splits the heap into fixed-size block chunks and hands
them out to workers, itself included, each claiming the next chunk
atomically. The leader always participates as a worker. The heap
scan and the index phases may use different worker counts, so
workers are launched at the start of each phase and exit at its
end.

Freezing cutoffs are computed once by the leader and shared, so
freezing decisions are identical across workers. Each worker prunes
using its own visibility state, so workers may remove slightly
different sets of recently-dead tuples, which is safe. Each worker
tracks the oldest XID/MXID it observes and its own scan counters;
the leader then combines these, taking the globally oldest XID/MXID
to advance the relation's frozen markers. Eager scanning of
all-visible pages for early freezing is distributed across workers
too.

When the dead-item store fills mid-scan, the heap scan pauses, the
indexes and heap are vacuumed, and the scan resumes. Per-worker
scan state is kept in shared memory so a worker can resume where it
left off, and the leader finishes any chunk left partly scanned
when a later round runs with fewer workers.

Vacuum is entered through the table AM, so the generic parallel
vacuum code must not call back up into the table AM. Instead an
access method supplies a ParallelVacuumCallbacks struct to
parallel_vacuum_init() and the generic code calls it without
knowing the access method, like logical decoding's output plugin
callbacks.
Worker callbacks cannot be passed as pointers across processes, so
the leader stores the access method name in shared memory and each
worker resolves the callbacks locally by that name, as the executor
does for custom scan methods.

The heap scan itself is what gets parallelized here. The later pass
that reaps dead line pointers from the heap is not. Testing showed
it is already the fastest phase, so parallelizing it gave little
overall benefit.

A TAP test exercises this using injection points, including worker
ramp-down across multiple scan rounds and the leader completing the
unfinished scans, plus the planned worker counts for different
PARALLEL requests and table sizes.

Performance numbers to follow.

Author: Masahiko Sawada <sawada.mshk@gmail.com>
Author: Bharath Rupireddy <bharath.rupireddyforpostgres@gmail.com>
Reviewed-by: Amit Kapila <amit.kapila16@gmail.com>
Reviewed-by: Hayato Kuroda <kuroda.hayato@fujitsu.com>
Reviewed-by: Peter Smith <smithpb2250@gmail.com>
Reviewed-by: Tomas Vondra <tomas@vondra.me>
Reviewed-by: Dilip Kumar <dilipbalaut@gmail.com>
Reviewed-by: Melanie Plageman <melanieplageman@gmail.com>
Reviewed-by: Andres Freund <andres@anarazel.de>
Discussion: https://postgr.es/m/CAD21AoAEfCNv-GgaDheDJ+s-p_Lv1H24AiJeNoPGCmZNSwL1YA@mail.gmail.com
---
 doc/src/sgml/ref/vacuum.sgml                  |   40 +-
 src/backend/access/heap/vacuumlazy.c          | 1242 +++++++++++++++--
 src/backend/commands/vacuumparallel.c         |  515 +++++--
 src/include/access/heapam.h                   |    8 +
 src/include/commands/vacuum.h                 |   84 +-
 src/test/modules/injection_points/Makefile    |    2 +
 src/test/modules/injection_points/meson.build |    5 +
 .../t/parallel_heap_vacuum.pl                 |  138 ++
 src/test/regress/expected/vacuum_parallel.out |    7 +
 src/test/regress/sql/vacuum_parallel.sql      |    8 +
 src/tools/pgindent/typedefs.list              |    8 +
 11 files changed, 1848 insertions(+), 209 deletions(-)
 create mode 100644 src/test/modules/injection_points/t/parallel_heap_vacuum.pl

diff --git a/doc/src/sgml/ref/vacuum.sgml b/doc/src/sgml/ref/vacuum.sgml
index 38ee973ea05..b07958ee93c 100644
--- a/doc/src/sgml/ref/vacuum.sgml
+++ b/doc/src/sgml/ref/vacuum.sgml
@@ -266,9 +266,43 @@ VACUUM [ ( <replaceable class="parameter">option</replaceable> [, ...] ) ] [ <re
     <term><literal>PARALLEL</literal></term>
     <listitem>
      <para>
-      Specifies the maximum number of parallel workers that can be used
-      for <xref linkend="parallel-vacuum"/>, which is further limited
-      by <xref linkend="guc-max-parallel-maintenance-workers"/>. This
+      Perform the <literal>scanning heap</literal>,
+      <literal>vacuuming indexes</literal>, and
+      <literal>cleaning up indexes</literal> phases of
+      <command>VACUUM</command> in parallel using
+      <replaceable class="parameter">integer</replaceable> background workers
+      (see <xref linkend="vacuum-phases"/> for details on each phase).
+     </para>
+     <para>
+      The number of workers used for the <literal>scanning heap</literal>
+      phase is determined based on the size of the table. A table can
+      participate in parallel <literal>scanning heap</literal> if and only if
+      its size is more than
+      <xref linkend="guc-min-parallel-table-scan-size"/>. During this phase,
+      the table's blocks will be divided into ranges and shared among the
+      cooperating processes. Each worker process will complete the scanning of
+      its given range of blocks before requesting an additional range of
+      blocks.
+     </para>
+     <para>
+      The number of workers used for the <literal>vacuuming indexes</literal>
+      and <literal>cleaning up indexes</literal> phases is equal to the number
+      of indexes on the table that support parallel vacuum. An index can
+      participate in parallel vacuum if and only if its size is more than
+      <xref linkend="guc-min-parallel-index-scan-size"/>. Only one worker can
+      be used per index. So parallel workers for these phases are launched only
+      when there are at least <literal>2</literal> indexes in the table.
+     </para>
+     <para>
+      Workers for vacuum are launched before the start of each phase and exit
+      at the end of the phase. The number of workers used in each phase is
+      capped by the number specified with the <literal>PARALLEL</literal>
+      option, if any, and in turn by
+      <xref linkend="guc-max-parallel-maintenance-workers"/>. It is not
+      guaranteed that the number of parallel workers specified by
+      <replaceable class="parameter">integer</replaceable> will be used during
+      execution; a vacuum may run with fewer workers than specified, or with
+      none at all. These behaviors might change in a future release. This
       option can't be used with the <literal>FULL</literal> option.
      </para>
     </listitem>
